设为首页收藏本站

[Android教程] Android 7.0及以上使用OpenCL

[复制链接]
查看1893 | 回复36 | 2018-11-18 17:25:17 | 显示全部楼层 |阅读模式
由于从Android 7.0, API 24, 开始, 系统将阻止应用链接至非公开NDK库, 所以, 使用libOpenCL.so时与面向低版本的Android平台有所不同, 需要把依赖的非公开NDK库打包到APK中
确定依赖的库
首先应该确定你所使用的libOpenC.so所依赖的库, 使用命令objdump -x libOpenCL.so | grep NEEDED,

Android 7.0及以上使用OpenCL

Android 7.0及以上使用OpenCL


这是在我的手机上面测试的情况, 那么我们需要做的是从手机上面, 把这些库全部pull出来, 然后打包到APK中. (在本例中, libc.so和libm.so是公开NDK库, 可以不用打包, 所以下面中没有打包)
打包依赖库
先是从手机/system/lib/目录下面把这些库pull出来, 然后把他们全部放到AndroidStudio工程的jniLibs目录下面,

Android 7.0及以上使用OpenCL

Android 7.0及以上使用OpenCL


然后在CMakeLists.txt中添加这些库
  1. add_library(libOpenCL SHARED IMPORTED )
  2. set_target_properties(libOpenCL PROPERTIES IMPORTED_LOCATION "${CMAKE_SOURCE_DIR}/src/main/jniLibs/armeabi-v7a/libOpenCL.so")
  3. add_library(libcutils SHARED IMPORTED )
  4. set_target_properties(libcutils PROPERTIES IMPORTED_LOCATION "${CMAKE_SOURCE_DIR}/src/main/jniLibs/armeabi-v7a/libcutils.so")
  5. add_library(libvndksupport SHARED IMPORTED )
  6. set_target_properties(libcutils PROPERTIES IMPORTED_LOCATION "${CMAKE_SOURCE_DIR}/src/main/jniLibs/armeabi-v7a/libvndksupport.so")
  7. add_library(libc++ SHARED IMPORTED )
  8. set_target_properties(libcutils PROPERTIES IMPORTED_LOCATION "${CMAKE_SOURCE_DIR}/src/main/jniLibs/armeabi-v7a/libc++.so")
复制代码

这样应该就没问题了, 如果执行时还有找不到库的报错, 按照同样的方法添加对相应库的依赖即可.


帖子地址: 

ylzhang | 2018-11-19 10:33:17 | 显示全部楼层
顶起出售广告位
iusidgi | 2018-11-19 10:33:21 | 显示全部楼层
支持你哈...................................
6363 | 2018-11-19 10:43:59 | 显示全部楼层
jackol007 | 2018-11-19 10:44:05 | 显示全部楼层
平常心啊~~~~~
yiyee123 | 2018-11-19 10:44:56 | 显示全部楼层
看起来好像不错的样子
eXyGsLaf | 2018-11-19 10:54:53 | 显示全部楼层
为保住菊花,这个一定得回复!
150550 | 2018-11-19 11:01:56 | 显示全部楼层
回个帖子,下班咯~
给我闪 | 2018-11-19 11:04:50 | 显示全部楼层
楼上的你说你来?
yehangdy | 2018-11-19 11:08:49 | 显示全部楼层
很无力%哎!……
您需要登录后才可以回帖 登录 | 点击加入

本版积分规则